<?php



/*setup*/
echo rex_view::title($this->i18n('capacity_title_extended'));
$content = $buttons = '';



/*save*/
if (rex_post('formsubmit', 'string') == '1') {
	$this->setConfig(rex_post('config', [
		['space', 'int']
	]));
}




/*battery display*/

function folderSize($dir){
	$size = 0;
	foreach (glob(rtrim($dir, '/').'/*', GLOB_NOSORT) as $each) {
		$size += is_file($each) ? filesize($each) : folderSize($each);
	}
	return $size;
}

function formatBytes($size, $precision = 2){
	$base = log($size, 1024);
	$suffixes = array('B', 'KB', 'MB', 'GB', 'TB');
	return round(pow(1024, $base - floor($base)), $precision) .' '. $suffixes[floor($base)];
}

$usage = round(folderSize(getcwd()) / ($this->getConfig('space')*1048576) *100,2);

switch(true) {
	case in_array(round($usage), range(0,20)):
		$battery = '0';
		break;
	case in_array(round($usage), range(21,40)):
		$battery = '1';
		break;
	case in_array(round($usage), range(41,60)):
		$battery = '2';
		break;
	case in_array(round($usage), range(61,80)):
		$battery = '3';
		break;
	case in_array(round($usage), range(81,100)):
		$battery = '4';
		break;
}

$style = '
font-size: 20rem;
margin-bottom: 2rem;
color: #3bb594;
text-orientation: upright;
';
$content .= '
<i class="fa fa-battery-'.$battery.'" style="'.$style.'" title="'.$usage.'%" ></i>
';



/*inputs*/
$formElements = [];
$n = [];
$n['label'] = '<label>'.rex_i18n::msg('capacity_spacename').'</label>';
$n['field'] = '<input class="form-control" type="text" name="config[space]" value="'.$this->getConfig('space').'" placeholder="'.rex_i18n::msg('capacity_placeholder').'" />';
$formElements[] = $n;
$fragment = new rex_fragment();
$fragment->setVar('elements', $formElements, false);
$content .= $fragment->parse('core/form/container.php');




/*savebutton*/
$formElements = [];
$n = [];
$n['field'] = '<button class="btn btn-save rex-form-aligned" type="submit" name="save">'.$this->i18n('capacity_refresh').'</button>';
$formElements[] = $n;
$fragment = new rex_fragment();
$fragment->setVar('elements', $formElements, false);
$buttons = $fragment->parse('core/form/submit.php');
$buttons = '<fieldset class="rex-form-action">'.$buttons.'</fieldset>';




/*form output*/
$fragment = new rex_fragment();
$fragment->setVar('class', 'edit');
$fragment->setVar('title', $this->i18n('capacity_fieldname').': '.formatBytes(folderSize(getcwd())));
$fragment->setVar('body', $content, false);
$fragment->setVar('buttons', $buttons, false);
$output = $fragment->parse('core/page/section.php');
$output = '
<form action="'.rex_url::currentBackendPage().'" method="post">
<input type="hidden" name="formsubmit" value="1" />'.$output.'</form>
';
echo $output;


